Attribute VB_Name = "WinAMPFE"
'----------------------------------------------------------------------
' Deeth WinAMP Front End Visual Basic Module
' Release 2
' By Murphy McCauley (MurphyMc@Concentric.NET) 08/16/99
'----------------------------------------------------------------------
' This has all the constants from Nullsoft's frontend.h converted to
' VB form.  Also, I've declared some API functions, constants, and
' structures (Types) that are useful when controlling WinAMP, and
' included GetWindowTitle() which gets the title for a given hWnd.
'----------------------------------------------------------------------
' http://www.fullspectrum.com/deeth/
'----------------------------------------------------------------------

Option Explicit

Declare Function CopyDataSendMessage Lib "user32" Alias _
"SendMessageA" (ByVal WndID As Long, ByVal wMsg As Long, _
ByVal wParam As Long, ByRef lParam As COPYDATASTRUCT) As Long

Declare Function lstrcpy Lib "kernel32" Alias "lstrcpyA" _
(ByVal lpString1 As String, ByVal lpString2 As String) _
As Long


Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" (ByVal hwnd As Long) As Long
Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Declare Function SendMessageM Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Declare Function IsWindow Lib "user32" (ByVal hwnd As Long) As Long
Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Const WM_USER = &H400
Public Const WM_COMMAND = &H111
Public Const WM_COPYDATA = &H4A
Public Const WM_WA_IPC = 1024

Public Type COPYDATASTRUCT
        dwData As Long
        cbData As Long
        lpData As Long
End Type

Public Const IPC_GETVERSION = 0
Public Const IPC_DELETE = 101
Public Const IPC_STARTPLAY = 102
Public Const IPC_ISPLAYING = 104
Public Const IPC_GETOUTPUTTIME = 105
Public Const IPC_JUMPTOTIME = 106
Public Const IPC_WRITEPLAYLIST = 120
Public Const IPC_SETPLAYLISTPOS = 121
Public Const IPC_SETVOLUME = 122
Public Const IPC_SETPANNING = 123
Public Const IPC_GETLISTLENGTH = 124
Public Const IPC_SETSKIN = 200
Public Const IPC_GETSKIN = 201
Public Const IPC_EXECPLUG = 202
Public Const IPC_GETPLAYLISTFILE = 211
Public Const IPC_GETPLAYLISTTITLE = 212
Public Const IPC_GETLISTPOS = 125
Public Const IPC_GETINFO = 126
Public Const IPC_GETEQDATA = 127
Public Const IPC_SETEQDATA = 128
Public Const IPC_PLAYFILE = 100
Public Const IPC_CHDIR = 103
Public Const WINAMP_OPTIONS_EQ = 40036              ' toggles the EQ window
Public Const WINAMP_OPTIONS_PLEDIT = 40040          ' toggles the playlist window
Public Const WINAMP_VOLUMEUP = 40058                ' turns the volume up a little
Public Const WINAMP_VOLUMEDOWN = 40059              ' turns the volume down a little
Public Const WINAMP_FFWD5S = 40060                  ' fast forwards 5 seconds
Public Const WINAMP_REW5S = 40061                   ' rewinds 5 seconds
Public Const WINAMP_BUTTON1 = 40044
Public Const WINAMP_BUTTON2 = 40045
Public Const WINAMP_BUTTON3 = 40046
Public Const WINAMP_BUTTON4 = 40047
Public Const WINAMP_BUTTON5 = 40048
Public Const WINAMP_BUTTON1_SHIFT = 40144
Public Const WINAMP_BUTTON2_SHIFT = 40145
Public Const WINAMP_BUTTON3_SHIFT = 40146
Public Const WINAMP_BUTTON4_SHIFT = 40147
Public Const WINAMP_BUTTON5_SHIFT = 40148
Public Const WINAMP_BUTTON1_CTRL = 40154
Public Const WINAMP_BUTTON2_CTRL = 40155
Public Const WINAMP_BUTTON3_CTRL = 40156
Public Const WINAMP_BUTTON4_CTRL = 40157
Public Const WINAMP_BUTTON5_CTRL = 40158
Public Const WINAMP_FILE_PLAY = 40029               ' pops up the load file(s) box
Public Const WINAMP_OPTIONS_PREFS = 40012           ' pops up the preferences
Public Const WINAMP_OPTIONS_AOT = 40019             ' toggles always on top
Public Const WINAMP_HELP_ABOUT = 40041

'--------------------------------------'
'      Command Message Constants       '
'--------------------------------------'


Public Const WA_PREVTRACK = 40044
Public Const WA_NEXTTRACK = 40048
Public Const WA_PLAY = 40045
Public Const WA_PAUSE = 40046
Public Const WA_STOP = 40047
Public Const WA_FADEOUTSTOP = 40147
Public Const WA_STOPAFTERTRACK = 40157
Public Const WA_FASTFORWARD = 40148                 '5 secs
Public Const WA_FASTREWIND = 40144                  '5 secs
Public Const WA_PLAYLISTHOME = 40154
Public Const WA_PLAYLISTEND = 40158
Public Const WA_DIALOGOPENFILE = 40029
Public Const WA_DIALOGOPENURL = 40155
Public Const WA_DIALOGFILEINFO = 40188
Public Const WA_TIMEDISPLAYELAPSED = 40037
Public Const WA_TIMEDISPLAYREMAINING = 40038
Public Const WA_TOGGLEPREFERENCES = 40012
Public Const WA_DIALOGVISUALOPTIONS = 40190
Public Const WA_DIALOGVISUALPLUGINOPTIONS = 40191
Public Const WA_STARTVISUALPLUGIN = 40192
Public Const WA_TOGGLEABOUT = 40041
Public Const WA_TOGGLEAUTOSCROLL = 40189
Public Const WA_TOGGLEALWAYSONTOP = 40019
Public Const WA_TOGGLEWINDOWSHADE = 40064
Public Const WA_TOGGLEPLAYLISTWINDOWSHADE = 40266
Public Const WA_TOGGLEDOUBLESIZE = 40165
Public Const WA_TOGGLEEQ = 40036
Public Const WA_TOGGLEPLAYLIST = 40040
Public Const WA_TOGGLEMAINWINDOW = 40258
Public Const WA_TOGGLEMINIBROWSER = 40298
Public Const WA_TOGGLEEASYMOVE = 40186
Public Const WA_VOLUMEUP = 40058                    'increase 1%
Public Const WA_VOLUMEDOWN = 40059                  'decrease 1%
Public Const WA_TOGGLEREPEAT = 40022
Public Const WA_TOGGLESHUFFLE = 40023
Public Const WA_DIALOGJUMPTOTIME = 40193
Public Const WA_DIALOGJUMPTOFILE = 40194
Public Const WA_DIALOGSKINSELECTOR = 40219
Public Const WA_DIALOGCONFIGUREVISUALPLUGIN = 40221
Public Const WA_RELOADSKIN = 40291
Public Const WA_CLOSE = 40001

'--------------------------------------'
'         User Message Constants       '
'--------------------------------------'
Public Const WA_GETVERSION = 0
Public Const WA_CLEARPLAYLIST = 101
Public Const WA_GETSTATUS = 104
Public Const WA_GETTRACKPOSITION = 105
Public Const WA_GETTRACKLENGTH = 105
Public Const WA_SEEKTOPOSITION = 106
Public Const WA_SETVOLUME = 122
Public Const WA_SETBALANCE = 123
Public Const WA_GETEQDATA = 127
Public Const WA_SETEQDATA = 128

' pops up the about box :)

Function GetWindowTitle(TheHWnd As Long) As String
    Dim Title As String
    If IsWindow(TheHWnd) Then
        Title = Space$(GetWindowTextLength(TheHWnd) + 1)
        Call GetWindowText(TheHWnd, Title, Len(Title))
        Title = Left$(Title, Len(Title) - 1)
    End If
    GetWindowTitle = Title
End Function
